--[[

	#############################################
	
		VMF CopyGun - Init
		
	#############################################
	
]]--

VMFCG = VMFCG or {}; -- This is the only table, which doesn't get overwritten on a script restart

-- ##############  Fixing problems with GMod standard Lua scripts for stupid people who never read my thread for "how to check your gmod working fine"
_OpenScript("VMFCopyGun/vmfcg_fix_for_stupid_people.lua"); -- Fixes some scripts, so they load, even when stupid people are infected with worms or simply removed these necessary files

-- #############################################
-- ############### Thirdparty stuff ####################
-- #############################################


if(not _Hud) then
	_OpenScript("VMFCopyGun/extensions/lb_extensions.lua"); -- Hud extension by h2-=NooB=- (used for XME and this VMFCG)
end
_OpenScript("VMFCopyGun/extensions/xm_base.lua"); -- Load h2-=NooB=-'s XME
if(not dbloader) then
	_OpenScript("VMFCopyGun/extensions/dbloader.lua"); -- Anders1's dbloader
end


-- #############################################
-- ############### VMFCG Files ######################
-- #############################################

_OpenScript("VMFCopyGun/vmfcg_lib.lua"); -- Library functions which handles datas
_OpenScript("VMFCopyGun/vmfcg_ini_parser.lua"); -- Parses INI files e.g. for the configuration of the script
_OpenScript("VMFCopyGun/vmfcg_config.lua"); -- Loads the config.ini file
_OpenScript("VMFCopyGun/vmfcg_commands.lua"); -- Rights management system
_OpenScript("VMFCopyGun/vmfcg_defines.lua"); -- Defines and constants for the script
_OpenScript("VMFCopyGun/vmfcg_core.lua"); -- Core functions, which hook into some special GMod functions (like _EntSetKeyValue)
_OpenScript("VMFCopyGun/vmfcg_think_unbreaker.lua"); -- Modified Think/Timer/Events scripts, which unbreak corrupt thinkfunctions
_OpenScript("VMFCopyGun/vmfcg_save_engine.lua"); -- Saver engine, which generates the VMF file
_OpenScript("VMFCopyGun/vmfcg_saveload.lua"); -- Handles save/load commands
_OpenScript("VMFCopyGun/vmfcg_database.lua"); -- Database engine which handles the DBLoader script
_OpenScript("VMFCopyGun/vmfcg_hud.lua"); -- Hud system for the Interface
_OpenScript("VMFCopyGun/vmfcg_menu.lua"); -- Our Kick-Ass menu which is powered by h2-=NooB=-'s XMemnu
_OpenScript("VMFCopyGun/vmfcg_ent_class.lua"); -- Entity Class for entity objects. You can create an object for any entity. Neccessary for saving etc.
_OpenScript("VMFCopyGun/vmfcg_entities.lua"); --  This is simply the entity cache, which saves any informations about Entitys which got modified by the game
_OpenScript("VMFCopyGun/vmfcg_selection.lua"); -- Handles selection of props for each player
_OpenScript("VMFCopyGun/vmfcg_tracelines.lua"); -- Generates a traceline object. Better usages than the _Trace functions
_OpenScript("VMFCopyGun/vmfcg_toolgun_fetch.lua"); -- Mainpart of the script - handles Toolgunevents to be able to save constraints, prop modifications etc.
_OpenScript("VMFCopyGun/vmfcg_swep_entity_hook.lua"); -- Hooks into SWEPs to fetch it's entity manipulations by e.g. EntSetKeyValue too (to be compatible to the CopyGun and other special SWEPs like ent_wretch)
_OpenScript("VMFCopyGun/vmfcg_rights_management.lua"); -- Rights management system, which handles the access of each person or group
_OpenScript("VMFCopyGun/vmfcg_copygun_converter.lua"); -- CopyGun Savefile converter. Converst CGs files to VMFs. (not very fast, but works very well :D)
_OpenScript("VMFCopyGun/vmfcg_remover.lua"); -- Handles the VMFLoader remover part!

-- #############################################
-- ############### VMFCG Init functions #################
-- #############################################

-- Loads visible debugmode (when activated in config)
if(VMFCG.config.debug and VMFCG.config.debug_position) then
	VMFCG.AddTimerOnce("VMFCG.debug_position",0.06,0,VMFCG.debug_position);
end
-- Loads the "fix for stupid people"
if(VMFCG.config.show_missing_luas_warning) then
	if(table.getn(VMFCG.Fix.FixedScripts) ~= 0) then
		VMFCG.AddTimerOnce("VMFCG.Fix.Warn",20,5,VMFCG.Fix.Warn);
	end
end
-- Show the splashscreen on server startup and give credits to me(aVoN)/Anders1 and h2noob ;)
VMFCG.SplashScreen();